unit NumTools;

interface
// 2   Degree
function Bin(Degree:Byte):LongWord;
//    
function BinToInt(BinValue:String):LongWord;
//    
function IntToBin(DecValue:LongWord;Positions:Byte=8):String;
//    
procedure SortIntegerSequence(var A: array of Integer);
//  
function GetPercent(nValue, nTotalValue: Real):Real;
implementation
uses
  SysUtils, StrTools, Dialogs;
//********************
function Bin(Degree:Byte):LongWord;
var
  i:Integer;
begin
  Result:=1;
  for i:=1 to Degree do Result:=Result*2;
end;
//********************
function BinToInt(BinValue:String):LongWord;
var
  i:Integer;
  StrLen:Integer;
begin
  Result:=0;
  BinValue:=Trim(ReverceString(BinValue));
  StrLen:=Length(BinValue);
  for i:=StrLen downto 1 do
  begin
    if BinValue[i]<>'0' then Result:=Result+Bin(i-1);
  end
end;
//********************
procedure SortIntegerSequence(var A: array of Integer);

  procedure QuickSort(var A: array of Integer; iLo, iHi: Integer);
  var
    Lo, Hi, Mid, T: Integer;
  begin
    Lo := iLo;
    Hi := iHi;
    Mid := A[(Lo + Hi) div 2];
    repeat
      while A[Lo] < Mid do Inc(Lo);
      while A[Hi] > Mid do Dec(Hi);
      if Lo <= Hi then
      begin
        //VisualSwap(A[Lo], A[Hi], Lo, Hi);
        T := A[Lo];
        A[Lo] := A[Hi];
        A[Hi] := T;
        Inc(Lo);
        Dec(Hi);
      end;
    until Lo > Hi;
    if Hi > iLo then QuickSort(A, iLo, Hi);
    if Lo < iHi then QuickSort(A, Lo, iHi);
    //if Terminated then Exit;
  end;

begin
  QuickSort(A, Low(A), High(A));
end;
//********************
function IntToBin(DecValue:LongWord;Positions:Byte=8):String;
var
  Remain:LongWord;
  TempResult:String;
  CurrRegister:Byte;
  CurrBin:LongWord;
  i:Byte;
  BeginPos:Byte;
begin
  Result:='';
  Remain:=DecValue;
  TempResult:='';
  CurrRegister:=31;
  for i:=0 to CurrRegister do
  begin
    CurrBin:=Bin(CurrRegister);
    if CurrBin>Remain then
    begin
      Result:=Result+'0';
    end
    else begin
      Result:=Result+'1';
      Remain:=Remain-CurrBin;
    end;
    Dec(CurrRegister,1);
  end;
  //     
  BeginPos:=Pos('1',Result);
  if BeginPos<>0 then Result:=Copy(Result,BeginPos,32-BeginPos+1);
  //  
  if Length(Result)<Positions then Result:=ReplicateChar(Positions-Length(Result),'0')+Result;
end;
//********************
function GetPercent(nValue, nTotalValue:Real):Real;
begin
  Result := nValue/nTotalValue*100;
end;
//********************
end.
